<?xml version="1.0" encoding="UTF-8"?>
<xliff xmlns="urn:oasis:names:tc:xliff:document:1.1" version="1.1">
  <file original="NoName" source-language="en" datatype="plaintext" target-language="fr">
    <body>
      <trans-unit xml:space="preserve" approved="no" id="021ad1871195999d">
        <source>Electronic mail</source>
        <target state="translated">Messagerie électronique</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">7</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="b8889fcc5792f1e2">
        <source>Electronic mail, or email, is a very popular application in computer networks such as the Internet. Email `appeared &lt;http://openmap.bbn.com/~tomlinso/ray/firstemailframe.html&gt;`_ in the early 1970s and allows users to exchange text based messages. Initially, it was mainly used to exchange short messages, but over the years its usage has grown. It is now not only used to exchange small, but also long messages that can be composed of several parts as we will see later.</source>
        <target state="translated">Les applications de messagerie électronique, ou email, sont populaires sur les réseaux informatiques comme Internet. L'email `est apparu &lt;http://openmap.bbn.com/~tomlinso/ray/firstemailframe.html&gt;`_  au début des années 1970 et permet aux utilisateurs d'échanger des messages sous forme textuelle. A la base, il était utilisé pour échanger de courts messages, mais sont utilisation n'a fait qu'augmenter ces dernières années. Il n'est plus seulement utilisé pour échanger de courts messages, mais également de longs messages pouvant être composés de différentes parties telles que nous le verrons par après.</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">11</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="71a16880cc817250">
        <source>Before looking at the details of Internet email, let us consider a simple scenario illustrated in the figure below, where Alice sends an email to Bob. Alice prepares her email by using an `email clients`_ and sends it to her email server. Alice's `email server &lt;http://en.wikipedia.org/wiki/Comparison_of_mail_servers&gt;`_ extracts Bob's address from the email and delivers the message to Bob's server. Bob retrieves Alice's message on his server and reads it by using his favorite email client or through his webmail interface.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">13</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c7c9894a3c582ddf">
        <source>The email system that we consider in this book is composed of four components :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">47</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ec66a91515139584">
        <source>a message format, that defines how valid email messages are encoded</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">49</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="b2ef2110fdb12de2">
        <source>protocols, that allow hosts and servers to exchange email messages</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">50</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="31aef33e99a36a05">
        <source>client software, that allows users to easily create and read email messages</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">51</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="761237edb4766862">
        <source>software, that allows servers to efficiently exchange email messages</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">52</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="cae18ff4be873ade">
        <source>We will first discuss the format of email messages followed by the protocols that are used on today's Internet to exchange and retrieve emails. Other email systems have been developed in the past [Bush1993]_ [Genilloud1990]_ [GC2000]_, but today most email solutions have migrated to the Internet email. Information about the software that is used to compose and deliver emails may be found on wikipedia_ among others, for both `email clients`_ and `email servers &lt;http://en.wikipedia.org/wiki/Comparison_of_mail_servers&gt;`_. More detailed information about the full Internet Mail Architecture may be found in :rfc:`5598`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">54</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7502bbf1db32970f">
        <source>Email messages, like postal mail, are composed of two parts :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">58</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="292e95937bb9b113">
        <source>a `header` that plays the same role as the letterhead in regular mail. It contains metadata about the message.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">60</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="359c199cc0935199">
        <source>the `body` that contains the message itself.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">61</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="8164cb36d90f9392">
        <source>Email messages are entirely composed of lines of ASCII characters. Each line can contain up to 998 characters and is terminated by the `CR` and `LF` control characters :rfc:`5322`. The lines that compose the `header` appear before the message `body`. An empty line, containing only the `CR` and `LF` characters, marks the end of the `header`. This is illustrated in the figure below.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">63</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="8ce6e3f901248eb2">
        <source>The email header contains several lines that all begin with a keyword followed by a colon and additional information. The format of email messages and the different types of header lines are defined in :rfc:`5322`. Two of these header lines are mandatory and must appear in all email messages :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">98</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="8bf3290774f1ef35">
        <source>The sender address. This header line starts with `From:`. This contains the (optional) name of the sender followed by its email address between `&lt;` and `&gt;`. Email addresses are always composed of a username followed by the `@` sign and a domain name.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="43733b0ef00e0dd6">
        <source>The date. This header line starts with `Date:`. :rfc:`5322` precisely defines the format used to encode a date.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">101</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="63401793e24367da">
        <source>Other header lines appear in most email messages. The `Subject:` header line allows the sender to indicate the topic discussed in the email. Three types of header lines can be used to specify the recipients of a message :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">103</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="3eb5fa675a01adb6">
        <source>the `To:` header line contains the email addresses of the primary recipients of the message [#fto]_. Several addresses can be separated by using commas.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">105</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="9077cee892f3c552">
        <source>the `cc:` header line is used by the sender to provide a list of email addresses that must receive a carbon copy of the message. Several addresses can be listed in this header line, separated by commas. All recipients of the email message receive the `To:` and `cc:` header lines.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">106</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="985859aa37051730">
        <source>the `bcc:` header line is used by the sender to provide a list of comma separated email addresses that must receive a blind carbon copy of the message. The `bcc:` header line is not delivered to the recipients of the email message.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">107</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="894df3c2289d9361">
        <source>A simple email message containing the `From:`, `To:`, `Subject:` and `Date:` header lines and two lines of body is shown below.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">109</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7b286b1a7ebf135a">
        <source>Note the empty line after the `Date:` header line; this empty line contains only the `CR` and `LF` characters, and marks the boundary between the header and the body of the message.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">122</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="6334a3756f7089be">
        <source>Several other optional header lines are defined in :rfc:`5322` and elsewhere [#femailheaders]_. Furthermore, many email clients and servers define their own header lines starting from `X-`. Several of the optional header lines defined in :rfc:`5322` are worth being discussed here :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">124</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="dda61a7532849b13">
        <source>the `Message-Id:` header line is used to associate a "unique" identifier to each email. Email identifiers are usually structured like `string@domain` where `string` is a unique character string or sequence number chosen by the sender of the email and `domain` the domain name of the sender. Since domain names are unique, a host can generate globally unique message identifiers concatenating a locally unique identifier with its domain name.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">126</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c06b10d354068e30">
        <source>the `In-reply-to:` header line is used when a message was created in reply to a previous message. In this case, the end of the `In-reply-to:` line contains the identifier of the original message.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">127</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="cad0da0148445a19">
        <source>the `Received:` header line is used when an email message is processed by several servers before reaching its destination. Each intermediate email server adds a `Received:` header line. These header lines are useful to debug problems in delivering email messages.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">128</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c09e4c24d12ba3e8">
        <source>The figure below shows the header lines of one email message. The message originated at a host named `wira.firstpr.com.au` and was received by `smtp3.sgsi.ucl.ac.be`. The `Received:` lines have been wrapped for readability.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="fe7287bc18706c31">
        <source>Initially, email was used to exchange small messages of ASCII text between computer scientists. However, with the growth of the Internet, supporting only ASCII text became a severe limitation for two reasons. First of all, non-English speakers wanted to write emails in their native language that often required more characters than those of the ASCII character table. Second, many users wanted to send other content than just ASCII text by email such as binary files, images or sound.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">166</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7966cb1335f3c6e5">
        <source>To solve this problem, the IETF_ developed the Multipurpose Internet Mail Extensions (:term:`MIME`). These extensions were carefully designed to allow Internet email to carry non-ASCII characters and binary files without breaking the email servers that were deployed at that time. This requirement for backward compatibility forced the MIME designers to develop extensions to the existing email message format :rfc:`822` instead of defining a completely new format that would have been better suited to support the new types of emails.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">170</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="b9d6f10f7a3f1bc8">
        <source>:rfc:`2045` defines three new types of header lines to support MIME :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">172</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="727295cde8b3f6e8">
        <source>The `MIME-Version:` header line indicates the version of the MIME specification that was used to encode the email message. The current version of MIME is 1.0. Other versions of MIME may be defined in the future. Thanks to this header line, the software that processes email messages will be able to adapt to the MIME version used to encode the message. Messages that do not contain this header are supposed to be formatted according to the original :rfc:`822` specification.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">174</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c05aa61690d1a36e">
        <source>The `Content-Type:` header line indicates the type of data that is carried inside the message (see below).</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">175</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="acdb7fbb813da31e">
        <source>The `Content-Transfer-Encoding:` header line is used to specify how the message has been encoded. When MIME was designed, some email servers were only able to process messages containing characters encoded using the 7 bits ASCII character set. MIME allows the utilization of other character encodings.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">176</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ed822b8e2a7f9856">
        <source>Inside the email header, the `Content-Type:` header line indicates how the MIME email message is structured. :rfc:`2046` defines the utilization of this header line. The two most common structures for MIME messages are :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">178</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a381c6a956c6f84d">
        <source>`Content-Type: multipart/mixed`. This header line indicates that the MIME message contains several independent parts. For example, such a message may contain a part in plain text and a binary file.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">180</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d12c3505b3e0e8df">
        <source>`Content-Type: multipart/alternative`. This header line indicates that the MIME message contains several representations of the same information. For example, a `multipart/alternative` message may contain both a plain text and an HTML version of the same text.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">181</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="05b549f8a142ee3f">
        <source>To support these two types of MIME messages, the recipient of a message must be able to extract the different parts from the message. In :rfc:`822`, an empty line was used to separate the header lines from the body. Using an empty line to separate the different parts of an email body would be difficult as the body of email messages often contains one or more empty lines. Another possible option would be to define a special line, e.g. `*-LAST_LINE-*` to mark the boundary between two parts of a MIME message. Unfortunately, this is not possible as some emails may contain this string in their body (e.g. emails sent to students to explain the format of MIME messages). To solve this problem, the `Content-Type:` header line contains a second parameter that specifies the string that has been used by the sender of the MIME message to delineate the different parts. In practice, this string is often chosen randomly by the mail client.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">183</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="fb2864c22727dc61">
        <source>The email message below, copied from :rfc:`2046` shows a MIME message containing two parts that are both in plain text and encoded using the ASCII character set. The string `simple boundary` is defined in the `Content-Type:` header as the marker for the boundary between two successive parts. Another example of MIME messages may be found in :rfc:`2046`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">186</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f8cf3e15bad673f4">
        <source>The `Content-Type:` header can also be used inside a MIME part. In this case, it indicates the type of data placed in this part. Each data type is specified as a type followed by a subtype. A detailed description may be found in :rfc:`2046`. Some of the most popular `Content-Type:` header lines are :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">210</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="e3bef5d65dd93c91">
        <source>`text`. The message part contains information in textual format. There are several subtypes : `text/plain` for regular ASCII text, `text/html` defined in :rfc:`2854` for documents in :term:`HTML` format or the `text/enriched` format defined in :rfc:`1896`. The `Content-Type:` header line may contain a second parameter that specifies the character set used to encode the text. `charset=us-ascii` is the standard ASCII character table.  Other frequent character sets include `charset=UTF8` or `charset=iso-8859-1`. The `list of standard character sets &lt;http://www.iana.org/assignments/character-sets&gt;`_ is maintained by :term:`IANA`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">212</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="03e9ab45be4e069e">
        <source>`image`. The message part contains a binary representation of an image. The subtype indicates the format of the image such as `gif &lt;http://en.wikipedia.org/wiki/Graphics_Interchange_Format&gt;`_, `jpg &lt;http://en.wikipedia.org/wiki/Jpeg&gt;`_ or `png &lt;http://en.wikipedia.org/wiki/Portable_Network_Graphics&gt;`_.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">213</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c0fe0be6af8e871b">
        <source>`audio`. The message part contains an audio clip. The subtype indicates the format of the audio clip like `wav &lt;http://en.wikipedia.org/wiki/Wav&gt;`_ or `mp3 &lt;http://en.wikipedia.org/wiki/Mp3&gt;`_.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">214</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="0e975251afd39009">
        <source>`video`. The message part contains a video clip. The subtype indicates the format of the video clip like `avi &lt;http://en.wikipedia.org/wiki/Audio_Video_Interleave&gt;`_ or `mp4 &lt;http://en.wikipedia.org/wiki/Mp4&gt;`_.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">215</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="957f7d4b24c38098">
        <source>`application`. The message part contains binary information that was produced by the particular application listed as the subtype. Email clients use the subtype to launch the application that is able to decode the received binary information.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">216</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="87baafd97a1c84cd">
        <source>From ASCII to Unicode</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">218</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="dba5606a656791b7">
        <source>The first computers used different techniques to represent characters in memory and on disk. During the 1960s, computers began to exchange information via tape or telephone lines. Unfortunately, each vendor had its own proprietary character set and exchanging data between computers from different vendors was often difficult. The 7 bits ASCII character table :rfc:`20` was adopted by several vendors and by many Internet protocols. However, ASCII became a problem with the internationalization of the Internet and the desire of more and more users to use character sets that support their own written language. A first attempt at solving this problem was the definition of the ISO-8859_ character sets by :term:`ISO`. This family of standards specified various character sets that allowed the representation of many European written languages by using 8 bits characters. Unfortunately, an 8-bits character set is not sufficient to support some widely used languages, such as those used in Asian countries. Fortunately, at the end of the 1980s, several computer scientists proposed to develop a standard that supports all written languages used on Earth today. The Unicode standard [Unicode]_ has now been adopted by most computer and software vendors. For example, Java always uses Unicode to manipulate characters, Python can handle both ASCII and Unicode characters. Internet applications are slowly moving towards complete support for the Unicode character sets, but moving from ASCII to Unicode is an important change that can have a huge impact on current deployed implementations. See, for example, the work to completely internationalize email :rfc:`4952` and domain names :rfc:`5890`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">220</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a2d19dccf2f52e8d">
        <source>The last MIME header line is `Content-Transfer-Encoding:`. This header line is used after the `Content-Type:` header line, within a message part, and specifies how the message part has been encoded. The default encoding is to use 7 bits ASCII. The most frequent encodings are `quoted-printable` and `Base64`. Both support encoding a sequence of bytes into a set of ASCII lines that can be safely transmitted by email servers. `quoted-printable` is defined in :rfc:`2045`. We briefly describe `base64` which is defined in :rfc:`2045` and :rfc:`4648`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">222</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="03522a093b8def67">
        <source>`Base64` divides the sequence of bytes to be encoded into groups of three bytes (with the last group possibly being partially filled). Each group of three bytes is then divided into four six-bit fields and each six bit field is encoded as a character from the table below.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">227</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="bd87947c6b564ecf">
        <source>Value</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="46785db69926a537">
        <source>Encoding</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">230</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">278</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">297</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">311</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="eba030ebb7f9b8e1">
        <source>0</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="287a02e2393009a5">
        <source>A</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a4f4cf10899f4937">
        <source>17</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="67bf3ea92a946894">
        <source>R</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ecd114eed9d88ecb">
        <source>34</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f68aec721a8f5f24">
        <source>i</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="b2de19cca6a5ba7a">
        <source>51</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="1355404933ec0a31">
        <source>z</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">232</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="dfbd4c12eb9e51b0">
        <source>1</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="814ecdfb11e6d57c">
        <source>B</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="59e0afd113919755">
        <source>18</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="1ea5cd521ef51bfc">
        <source>S</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ba9374b5a2e12195">
        <source>35</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="85fb1d032c87ff26">
        <source>j</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="84688fde34d7e6ad">
        <source>52</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">234</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="006009681cb2e26c">
        <source>2</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="b713f5b3d13f3306">
        <source>C</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d5c391003c0c2bee">
        <source>19</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="3f947ca5265c26ae">
        <source>T</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7eeb05c49abe9056">
        <source>36</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c6cef054b486c648">
        <source>k</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="09da03d49ee778d7">
        <source>53</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">236</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="b17c7d9edacecbaf">
        <source>3</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="4c4e1875c5665ecf">
        <source>D</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="404a11b0aac0370e">
        <source>20</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="2b55a89573d3d4b4">
        <source>U</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="3c12b36992d8e440">
        <source>37</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="dba573049e679931">
        <source>l</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="bb063810d01dee37">
        <source>54</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">238</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="3174f6bcbef734ab">
        <source>4</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="6d61e3edd1cbc5dd">
        <source>E</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="8665267e8b32947f">
        <source>21</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="dababf0e5ee41176">
        <source>V</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c7031d6e6b43daca">
        <source>38</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="4a993ab905a20f6b">
        <source>m</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="cc9bec44b521f836">
        <source>55</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">240</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="1214f1507fe8dc50">
        <source>5</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="22cffd65890eafae">
        <source>F</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="434072200776ed76">
        <source>22</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="95d32f7092748c28">
        <source>W</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="fe95f78dedf73190">
        <source>39</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="53cd9440b79fe130">
        <source>n</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="921617d2931790f1">
        <source>56</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">242</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c789e1896697ebbd">
        <source>6</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="58dd9b4fa93dc3fe">
        <source>G</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="4b0e2ee1f0c38b9b">
        <source>23</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="82918c3da1cd4d0f">
        <source>X</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d0cb3459bc05c825">
        <source>40</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="94d46517560e58e4">
        <source>o</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="1d9d7f64f60a3c3c">
        <source>57</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">244</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="766a0fe2e87a5112">
        <source>7</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="edb8e53dbcd7d753">
        <source>H</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c0b17578890134cd">
        <source>24</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d20446c5c2eb82df">
        <source>Y</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="255a790b3d8b5d63">
        <source>41</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d800095b11f7ad38">
        <source>p</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="39bc777a74a41861">
        <source>58</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">246</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="62ac44bfd909abd5">
        <source>8</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ed1099810a7c20eb">
        <source>I</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ce174557be879708">
        <source>25</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="55f9bec046de3613">
        <source>Z</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="5afaa0ff744368b6">
        <source>42</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="fd98f4e931601b7a">
        <source>q</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="38e1e3f988ef6d9a">
        <source>59</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">248</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="77ded408bee56fd1">
        <source>9</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="201a6cf2016ef197">
        <source>J</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c2240e3a34d5ed17">
        <source>26</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="70f263be86bc0985">
        <source>a</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f7333c9998c26eb2">
        <source>43</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ae824dc3d43d77f9">
        <source>r</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ecc56b47eb95b077">
        <source>60</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">250</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7cef57593256badd">
        <source>10</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ae9b1e383b37eeae">
        <source>K</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="09114e11d4dd4f8d">
        <source>27</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="dd0735134eebce3b">
        <source>b</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c234f96c390558f4">
        <source>44</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="3f07e25f5162a287">
        <source>s</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f63ba1d9867ed13e">
        <source>61</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">252</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a03be57bb8f2f8ce">
        <source>11</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="0d672765e36d4847">
        <source>L</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="3a9a83a1ed19af59">
        <source>28</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c1421a4cdb692a34">
        <source>c</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f2676f87a76b40dc">
        <source>45</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="8ec6517272543813">
        <source>t</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ec06b3411bf815aa">
        <source>62</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="1e0e2d4de1ab80d0">
        <source>\+</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">254</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="05ce2c3201034a35">
        <source>12</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="89f0fa4c1fa56efd">
        <source>M</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="09daaf8f8167bed4">
        <source>29</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="563e6e4042184f65">
        <source>d</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="799d873d15d3a782">
        <source>46</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="9f047b1aa60d5647">
        <source>u</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="aaa6702538beb4cf">
        <source>63</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="80108ec9cf902f88">
        <source>/</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">256</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="527badb3fe60638c">
        <source>13</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">258</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ff0dfa51fcfd621e">
        <source>N</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">258</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="da8a72d792888d47">
        <source>30</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">258</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="9817260643c1477d">
        <source>e</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">258</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="51c77abf5e0f5be9">
        <source>47</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">258</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="52a5c5e50085f541">
        <source>v</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">258</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="9de04020d95dcfb5">
        <source>14</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">260</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d854c67e917c28be">
        <source>O</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">260</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="82de371cbedabc0a">
        <source>31</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">260</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f4d90b243485767c">
        <source>f</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">260</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d35131f053280650">
        <source>48</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">260</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f1b9591251c5c4c4">
        <source>w</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">260</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="2b13ab1e55cea292">
        <source>15</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">262</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f1113eb442d15b46">
        <source>P</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">262</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="eeff74c1f46c6161">
        <source>32</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">262</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c14a5ebd338dc8cf">
        <source>g</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">262</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="986e5cd141ea980c">
        <source>49</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">262</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ba352f851cd423bf">
        <source>x</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">262</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a15639a0aa4f079e">
        <source>16</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">264</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="2ffbbfa6400b65c0">
        <source>Q</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">264</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="303ca34bc6d85447">
        <source>33</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">264</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="8905669966489134">
        <source>h</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">264</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="5bf0795961a95ae0">
        <source>50</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">264</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="819b0ee5620abc3f">
        <source>y</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">264</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="f37ac7b8a15ce215">
        <source>The example below, from :rfc:`4648`, illustrates the `Base64` encoding.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">267</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="529048d79331059a">
        <source>Input data</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">270</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">289</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">303</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="6b74ec71cf3d5dc3">
        <source>`0x14fb9c03d97e`</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">270</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="6f6819252d96e4ae">
        <source>8-bit</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">272</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">291</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">305</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="e3b42ed608597f3f">
        <source>00010100 11111011 10011100   00000011 11011001 01111110</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">272</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="785b33c6a5032e48">
        <source>6-bit</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">274</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">293</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">307</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="b329ccae4716e76a">
        <source>000101 001111 101110 011100  000000 111101 100101 111110</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">274</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a20098c7153ab58e">
        <source>Decimal</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">276</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">295</context>
        </context-group>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">309</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="04c166bb61fb287f">
        <source>5      15     46     28      0     61     37     62</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">276</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="6e5f9028353a6446">
        <source>F      P      u      c       A      9      l      \+</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">278</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="935faeace3e5bb04">
        <source>The last point to be discussed about `base64` is what happens when the length of the sequence of bytes to be encoded is not a multiple of three. In this case, the last group of bytes may contain one or two bytes instead of three. `Base64` reserves the `=` character as a padding character. This character is used once when the last group contains two bytes and twice when it contains one byte as illustrated by the two examples below.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">286</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d028634f1913ee48">
        <source>0x14</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">289</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="86659309e1982cb7">
        <source>00010100</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">291</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="23c6ace150bf5314">
        <source>000101 000000</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">293</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="70f7950824da86c7">
        <source>5     0</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">295</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d94e992406b9bf03">
        <source>F     A    \=  \=</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">297</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7f24fa68b152b1cb">
        <source>0x14b9</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">303</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="312940ae92b9d8b9">
        <source>00010100  11111011</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">305</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a240dcdcb44dae4a">
        <source>000101 001111 101100</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">307</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d5ed855a241afb55">
        <source>5    15      44</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">309</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="39bcf39e0bdc1462">
        <source>F     P       s     \=</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">311</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="bc081d87300e5d47">
        <source>Now that we have explained the format of the email messages, we can discuss how these messages can be exchanged through the Internet. The figure below illustrates the protocols that are used when `Alice` sends an email message to `Bob`. `Alice` prepares her email with an email client or on a webmail interface. To send her email to `Bob`, `Alice`'s client will use the Simple Mail Transfer Protocol (:term:`SMTP`) to deliver her message to her SMTP server. `Alice`'s email client is configured with the name of the default SMTP server for her domain. There is usually at least one SMTP server per domain. To deliver the message, `Alice`'s SMTP server must find the SMTP server that contains `Bob`'s mailbox. This can be done by using the Mail eXchange (MX) records of the DNS. A set of MX records can be associated to each domain. Each MX record contains a numerical preference and the fully qualified domain name of a SMTP server that is able to deliver email messages destined to all valid email addresses of this domain. The DNS can return several MX records for a given domain. In this case, the server with the lowest numerical preference is used first :rfc:`2821`. If this server is not reachable, the second most preferred server is used etc. `Bob`'s SMTP server will store the message sent by `Alice` until `Bob` retrieves it using a webmail interface or protocols such as the Post Office Protocol (:term:`POP`) or the Internet Message Access Protocol (:term:`IMAP`).</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">318</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c454a0d47ef10bea">
        <source>The Simple Mail Transfer Protocol</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">342</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ec755a1e871f5586">
        <source>The Simple Mail Transfer Protocol (:term:`SMTP`) defined in :rfc:`5321` is a client-server protocol. The SMTP specification distinguishes between five types of processes involved in the delivery of email messages. Email messages are composed on a Mail User Agent (MUA). The MUA is usually either an email client or a webmail. The MUA sends the email message to a Mail Submission Agent (MSA). The MSA processes the received email and forwards it to the Mail Transmission Agent (MTA). The MTA is responsible for the transmission of the email, directly or via intermediate MTAs to the MTA of the destination domain. This destination MTA will then forward the message to the Mail Delivery Agent (MDA) where it will be accessed by the recipient's MUA. SMTP is used for the interactions between MUA and MSA [#fsmtpauth]_, MSA-MTA and MTA-MTA.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">344</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="5c0fe3651ea95f72">
        <source>SMTP is a text-based protocol like many other application-layer protocols on the Internet. It relies on the byte-stream service. Servers listen on port `25`. Clients send commands that are each composed of one line of ASCII text terminated by `CR+LF`. Servers reply by sending ASCII lines that contain a three digit numerical error/success code and optional comments.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">346</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="52cfc9d9d4893f3e">
        <source>The SMTP protocol, like most text-based protocols, is specified as a :term:`BNF`. The full BNF is defined in :rfc:`5321`. The main SMTP commands are defined by the BNF rules shown in the figure below.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">348</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="db823ae91fbbdb88">
        <source>BNF specification of the SMTP commands</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">354</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ca8fda456c02ec53">
        <source>In this BNF, `atext` corresponds to printable ASCII characters. This BNF rule is defined in :rfc:`5322`. The five main commands are `EHLO` [#fehlo]_, `MAIL FROM:`, `RCPT TO:`, `DATA` and `QUIT`. `Postmaster` is the alias of the system administrator who is responsible for a given domain or SMTP server. All domains must have a `Postmaster` alias.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">356</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="0d81101ee714efc0">
        <source>The SMTP responses are defined by the BNF shown in the figure below.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">358</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="73c1400f9ee1fe55">
        <source>BNF specification of the SMTP responses</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">363</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="def4e614408ac0cf">
        <source>SMTP servers use structured reply codes containing three digits and an optional comment. The first digit of the reply code indicates whether the command was successful or not. A reply code of `2xy` indicates that the command has been accepted. A reply code of `3xy` indicates that the command has been accepted, but additional information from the client is expected. A reply code of `4xy` indicates a transient negative reply. This means that for some reason, which is indicated by either the other digits or the comment, the command cannot be processed immediately, but there is some hope that the problem will only be transient. This is basically telling the client to try the same command again later. In contrast, a reply code of `5xy` indicates a permanent failure or error. In this case, it is useless for the client to retry the same command later. Other application layer protocols such as FTP :rfc:`959`  or HTTP :rfc:`2616` use a similar structure for their reply codes. Additional details about the other reply codes may be found in :rfc:`5321`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">366</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="4f83711b4654050e">
        <source>Examples of SMTP reply codes include the following :</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">368</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="e23c7261c94f05c8">
        <source>Reply code `220` is used by the server as the first message when it agrees to interact with the client. Reply code `221` is sent by the server before closing the underlying transport connection. Reply code `250` is the standard positive reply that indicates the success of the previous command. Reply code `354` indicates that the client can start transmitting its email message. Reply code `421` is returned when there is a problem (e.g. lack of memory/disk resources) that prevents the server from accepting the transport connection.  Reply codes `450` and `452` indicate that the destination mailbox is temporarily unavailable, for various reasons, while reply code `550` indicates that the mailbox does not exist or cannot be used for policy reasons.  The `500` to `503` reply codes correspond to errors in the commands sent by the client. The `503` reply code would be sent by the server when the client sends commands in an incorrect order (e.g. the client tries to send an email before providing the destination address of the message).</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">387</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="544915a9c121565b">
        <source>The transfer of an email message is performed in three phases. During the first phase, the client opens a transport connection with the server. Once the connection has been established, the client and the server exchange greetings messages (`EHLO` command). Most servers insist on receiving valid greeting messages and some of them drop the underlying transport connection if they do not receive a valid greeting. Once the greetings have been exchanged, the email transfer phase can start. During this phase, the client transfers one or more email messages by indicating the email address of the sender (`MAIL FROM:` command), the email address of the recipient (`RCPT TO:` command) followed by the headers and the body of the email message (`DATA` command). Once the client has finished sending all its queued email messages to the SMTP server, it terminates the SMTP association (`QUIT` command).</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">389</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="daae1eb97edbe3f2">
        <source>A successful transfer of an email message is shown below</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">391</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="819dede55bb41d1a">
        <source>In the example above, the MTA running on `mta.example.org` opens a TCP connection to the SMTP server on host `smtp.example.com`. The lines prefixed with `S:` (resp. `C:`) are the responses sent by the server (resp. the commands sent by the client). The server sends its greetings as soon as the TCP connection has been established. The client then sends the `EHLO` command with its fully qualified domain name. The server replies with reply-code `250` and sends its greetings. The SMTP association can now be used to exchange an email.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">418</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="06f11035109cc4f2">
        <source>To send an email, the client must first provide the address of the recipient with `RCPT TO:`. Then it uses the `MAIL FROM:` with the address of the sender. Both the recipient and the sender are accepted by the server. The client can now issue the `DATA` command to start the transfer of the email message. After having received the `354` reply code, the client sends the headers and the body of its email message. The client indicates the end of the message by sending a line containing only the `.` (dot) character [#fdot]_. The server confirms that the email message has been queued for delivery or transmission with a reply code of `250`. The client issues the `QUIT` command to close the session and the server confirms with reply-code `221`, before closing the TCP connection.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">420</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="0d1382d74300a42f">
        <source>Open SMTP relays and spam</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">423</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="4b273890a0e973da">
        <source>Since its creation in 1971, email has been a very useful tool that is used by many users to exchange lots of information. In the early days, all SMTP servers were open and anyone could use them to forward emails towards their final destination. Unfortunately, over the years, some unscrupulous users have found ways to use email for marketing purposes or to send malware. The first documented abuse of email for marketing purposes occurred in 1978 when a marketer who worked for a computer vendor sent a `marketing email &lt;http://www.templetons.com/brad/spamreact.html#msg&gt;`_ to many ARPANET users. At that time, the ARPANET could only be used for research purposes and this was an abuse of the acceptable use policy. Unfortunately, given the extremely low cost of sending emails, the problem of unsolicited emails has not stopped. Unsolicited emails are now called spam and a `study &lt;http://www.enisa.europa.eu/act/res/other-areas/anti-spam-measures&gt;`_ carried out by ENISA_ in 2009 reveals that 95% of email was spam and this number seems to continue to grow. This places a burden on the email infrastructure of Internet Service Providers and large companies that need to process many useless messages.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">425</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="d8bbd10d05613e54">
        <source>Given the amount of spam messages, SMTP servers are no longer open :rfc:`5068`. Several extensions to SMTP have been developed in recent years to deal with this problem. For example, the SMTP authentication scheme defined in :rfc:`4954` can be used by an SMTP server to authenticate a client. Several techniques have also been proposed to allow SMTP servers to `authenticate` the messages sent by their users :rfc:`4870` :rfc:`4871` .</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">427</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="876008a0641f1d6e">
        <source>The Post Office Protocol</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">433</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c95ec4564fe94d04">
        <source>When the first versions of SMTP were designed, the Internet was composed of minicomputers that were used by an entire university department or research lab. These minicomputers were used by many users at the same time. Email was mainly used to send messages from a user on a given host to another user on a remote host. At that time, SMTP was the only protocol involved in the delivery of the emails as all hosts attached to the network were running an SMTP server. On such hosts, an email destined to local users was delivered by placing the email in a special directory or file owned by the user. However, the introduction of personal computers in the 1980s changed this environment. Initially, users of these personal computers used applications such as :term:`telnet` to open a remote session on the local :term:`minicomputer` to read their email. This was not user-friendly. A better solution appeared with the development of user friendly email client applications on personal computers. Several protocols were designed to allow these client applications to retrieve the email messages destined to a user from his/her server. Two of these protocols became popular and are still used today. The Post Office Protocol (POP), defined in :rfc:`1939`, is the simplest one. It allows a client to download all the messages destined to a given user from his/her email server. We describe POP briefly in this section. The second protocol is the Internet Message Access Protocol (IMAP), defined in :rfc:`3501`. IMAP is more powerful, but also more complex than POP. IMAP was designed to allow client applications to efficiently access, in real-time, to messages stored in various folders on servers. IMAP assumes that all the messages of a given user are stored on a server and provides the functions that are necessary to search, download, delete or filter messages.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">435</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c2f0e9105ccfae8f">
        <source>POP is another example of a simple line-based protocol. POP runs above the bytestream service. A POP server usually listens to port 110. A POP session is composed of three parts : an `authorisation` phase during which the server verifies the client's credential, a `transaction` phase during which the client downloads messages and an `update` phase that concludes the session. The client sends commands and the server replies are prefixed by `+OK` to indicate a successful command or by `-ERR` to indicate errors.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">437</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="49725a62b2cb786d">
        <source>When a client opens a transport connection with the POP server, the latter sends as banner an ASCII-line starting with `+OK`. The POP session is at that time in the `authorisation` phase. In this phase, the client can send its username (resp. password) with the `USER` (resp. `PASS`) command. The server replies with `+OK` if the username (resp. password) is valid and `-ERR` otherwise.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">439</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="5a7d962f77b56836">
        <source>Once the username and password have been validated, the POP session enters in the `transaction` phase. In this phase, the client can issue several commands. The `STAT` command is used to retrieve the status of the server. Upon reception of this command, the server replies with a line that contains `+OK` followed by the number of messages in the mailbox and the total size of the mailbox in bytes. The `RETR` command, followed by a space and an integer, is used to retrieve the nth message of the mailbox. The `DELE` command is used to mark for deletion the nth message of the mailbox.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">441</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="550307c8bd691293">
        <source>Once the client has retrieved and possibly deleted the emails contained in the mailbox, it must issue the `QUIT` command. This command terminates the POP session and allows the server to delete all the messages that have been marked for deletion by using the `DELE` command.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">443</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="ac5e64e66123261c">
        <source>The figure below provides a simple POP session. All lines prefixed with `C:` (resp. `S:`) are sent by the client (resp. server).</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">445</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="7840b883859989e9">
        <source>In this example, a POP client contacts a POP server on behalf of the user named `alice`. Note that in this example, Alice's password is sent in clear by the client. This implies that if someone is able to capture the packets sent by Alice, he will know Alice's password [#fapop]_. Then Alice's client issues the `STAT` command to know the number of messages that are stored in her mailbox. It then retrieves and deletes the first message of the mailbox.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">471</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="c463aea6549199a2">
        <source>Footnotes</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">482</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="03a9ad5d3921cc37">
        <source>It could be surprising that the `To:` is not mandatory inside an email message. While most email messages will contain this header line an email that does not contain a `To:` header line and that relies on the `bcc:` to specify the recipient is valid as well.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">483</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="4bf63c5deb6c90af">
        <source>The list of all standard email header lines may be found at http://www.iana.org/assignments/message-headers/message-header-index.html</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">485</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="a663e725501c6ec6">
        <source>During the last years, many Internet Service Providers, campus and enterprise networks have deployed SMTP extensions :rfc:`4954` on their MSAs. These extensions force the MUAs to be authenticated before the MSA accepts an email message from the MUA.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">487</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="9fe7736bd9abf7aa">
        <source>The first versions of SMTP used `HELO` as the first command sent by a client to a SMTP server. When SMTP was extended to support newer features such as 8 bits characters, it was necessary to allow a server to recognize whether it was interacting with a client that supported the extensions or not. `EHLO` became mandatory with the publication of :rfc:`2821`.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">489</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="64bcef713c433209">
        <source>This implies that a valid email message cannot contain a line with one dot followed by `CR` and `LF`. If a user types such a line in an email, his email client will automatically add a space character before or after the dot when sending the message over SMTP.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">491</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" id="982a11bfb0fda389">
        <source>:rfc:`1939` defines the APOP authentication scheme that is not vulnerable to such attacks.</source>
        <target></target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile">../../protocols/email.rst</context>
          <context context-type="linenumber">493</context>
        </context-group>
      </trans-unit>
    </body>
  </file>
</xliff>
